\documentclass{scrreprt}
\usepackage[dvipsnames]{xcolor} % For using colors with \textcolor{<color>}{<text>}
\usepackage{hyperref}

\title{Reducing the Complexity of OC-DFGs}
\author{Simon Glomb, Stanislav Yuliyanov, Lennart Holzenkamp}

\begin{document}
\maketitle

\tableofcontents

\chapter*{Revision History}

\chapter{Introduction}
    \section{Purpose}

        This Software Requirements Specifications serves as the first revision regarding the project titled 
        "Reducing the complexity of Object-Centric Direct-Follows-Graphs".
        The project will be developed during the course "Process Discovery Using Python" at RWTH Aachen University.
        The project will mainly implement two different clustering techniques
        (so called All and Existence approach). These techniques will be specified later on.

        % This SRS serves as the first revision and a documentation regarding the project “CT for OC-DFGs”. The project goal is to reduce the complexity of Object-Centric Directly-Follows Graphs. Two clustering approaches will be introduced and implemented:
        % 1.	Existence: We directly assign events to the clusters by considering that the event should contain at least one of the objects in the cluster.
        % 2.	All: In this approach, to avoid convergence, we assign an event to a cluster, if the cluster contains all the objects that exist in that event. 


    \section{Document Conventions}

        This document is written with LaTeX\cite{LaTeX_Organisation}. Hence the formatting is specified 
        in a .tex file. Its sections are a subset of the sections proposed in the IEEE Guide for 
        Software Requirements Specifications\cite{IEEE_SRS_Guide}. 

        % As of the current revision, no standards or typographical conventions were followed during the writing of this SRS.

    \section{Intended Audience and Reading Suggestions}

        This document is intended for the team members of the project, the course instructors and participants 
        of the course "Process Discovery Using Python". \par

        Anahita Farhang Ghahfarokhi proposed this project during the previously mentioned course. Additionally to 
        all the documents cited under \textit{references} the proposal\cite{ProjectProposal} should be read first as a introduction.
        This document is based on this proposal. This project aims to implement the two strategies for 
        clustering object centric event logs described by A. Farhang Ghahfarokhi et al.\cite{ClusteringObjectCentricEventLogs}.

        % The final product will be open-source and available publicly, and therefore accessible for researchers and developers in the field of Process Discovery, specifically the development of more effective Directly-Follows Graphs based on the Object-Centric structure. 

    \section{Product Scope}

        The product scope is mainly the clustering of OCEL data based on input settings 
        to achieve an understanding of the data by consindering the OCEL-DFG (with reduced complexity)
        which will be generated by the program. \par
        
        The scope of the project is not to recommend special attributes subsets or similiar which may be useful 
        for users of the software. It is not the target to have a general approach how to reduce a OC-DFG. \par

        Its purpose is to provide a piece of software that is able to use input parameters and clustering OCEL data in 
        an OC-DFG as proposed by Farhang Ghahfarokhi et al.\cite{ClusteringObjectCentricEventLogs}.

        % The product scope has been specified in more detail in the article Clustering Object-Centric Event Logs which is referenced in Section 1.5:

    \section{References}
        \subsection{Definition of OCEL-format}
        OCEL is a standard format for exchanging object-centric event data 
        developed by the Process and Data Science Group (PADS) at 
        RWTH Aachen University\cite{OCEL_Standard}

        \subsection{PM4Py}
        Process Mining for Python\cite{PM4Py} (PM4Py) is a open source process mining platform which will be used during the Implementation
        of the project.

    % 1.	PM4PY: Link
    % 2.	Anahita Farhang Ghahfarokhi , Fatemeh Akoochekian , Fareed Zandkarimi , and Wil M.P. van der Aalst. Clustering Object-Centric Event Logs. PADS RWTH Aachen. July 2021

\chapter{Overall Description}
    \section{Product Perspective}
        The product aims to be a ready-to-deploy software which can import OCEL-Data and a configuration
        (filter attributes, clustering mode) and export an OC-DFG which is less complex than the DFG generated by the plain
        input. \par

        These functions lead to several use cases. For example using OCEL Data for business projects and analyze the underlying
        process from different perspectives, and gain further understanding of bottlenecks and the general structure of a 
        process. Hence it may be able to improve processes in all kinds of industries. \par

        Optional, the product can help improve clustering algorithms and may lead to better understanding as to which clustering 
        technique is suitable for which scenario, specifically comparing the "all" and "existence" approaches. \par

        The project will focus on the clustering of OCEL data and use libraries for visualization and parsing, imporing and exporting
        data.

        % PM4PY is python library that supports process mining algorithms. It is open-source and people from an academic or industrial background can make use of the library for their projects. Moreover, it supports the discovery of process models, which require event logs as an input. The Object-Centric Event Logs (OCELs) are one of the more recent attempts to tackle with real-life challenges, such as Business-to-Business (B2B) processes, where multiple objects are involved in a process. Currently, the output of the proposed discovery techniques on real OCELs leads to more informative but also more complex models [2].
        % This project aims to provide two clustering-based techniques on top of the provided ones to reduce the complexity of the produced DFGs while maintaining the integrity of the extracted insights. 


    \section{Product Functions}

        The product will offer complexity reduction of Direct-Follows-Graphs based on Object-Centric Event Data.
        Thererfore it will work in the following steps:

        \begin{itemize}
            \item Read in input data
                \begin{itemize}
                    \item Setting the clustering mode (all/existence)
                    \item Parsing OCEL-file as .xml or .json file according to the OCEL standard \cite{OCEL_Standard}
                    \item Reading in the desired attributes used for clustering
                \end{itemize}

            \item Cluster data using the selected clustering mode
            \item Create and export the DFGs and event logs per cluster based on the clustering.
        \end{itemize}

        % The currently planned functions covered by this project are as followed:
        % 1)	Clustering techniques
        %   a.  	“All”
        %   b.	    “Existential
        % Any additional functionality that is responsible for the import, export, or visualization of the OCEL as a DFG is already provided in the PM4PY library. Hence, the goal of this project is to only focus on the implementation of the abovementioned functions.

    \section{User Classes and Characteristics}
        
        \subsection{Researches}
            Researches may use the product to analyze different OCEL-data and clustering settings to gain further knowledge.
            Also they may potentially adopt techniques in other research areas or enable further clustering techniques.

        \subsection{Corporations}
            Corporations who are interested in gaining knowledge about their processes can integrate the software in their
            Analytics Tech Stack.

        % Ideally, two types of user classes can make use of the project:
        % • OCEL Developers who are looking for implementation of new clustering techniques allowing a less complex DFGs to be compiled.
        % •	Corporations who have adopted the OCEL-Standard

    \section{Operating Environment}

        The product will be deployable as a Docker container. Hence, it will be compatible with operating systems that 
        are supported by docker. Additionally this benefits in scalability and deployment scenarios as users of the software
        are able to deploy it to various environments (e.g. cloud providers, own datacenters or local machines). \par
        
        The docker container will be used in a web-based sample application (possibly Jupyter Notebook) for showing
        all the features and give users an easy entry to start example analysis and gain further understanding of the product.\par

        The code itself will be written in Python 3 and use several libraries for Python.

        % To maximize the compatibility with modern widely used operating environments (Linux, Windows, macOS), the source code, which will be written in Python, will be publicly available for everyone to compile and edit for their needs as pleased.

    \section{Design and Implementation Constraints}
        \subsection{Time complexity}
            The program should be able to terminate in terms of minutes on a representative OCEL sample (See OCEL examples 
            on the website: \href{http://ocel-standard.org/}{ocel-standard.org})
        \subsection{Data types}
            The project is limited to use data which is given either in the .xml or .json version
            following the OCEL standard\cite{OCEL_Standard}.
        \subsection{Versions}
            The dependencies which this project utilizes will work with the following software versions:
            \begin{itemize}
                \item Python 3.9.7
                \item NumPy 1.22.0
                \item PM4Py 0.0.36
                \item Docker 4.7.1
            \end{itemize}

            \textit{Disclaimer:} This section will have additions and changes throughout the project. 

        % For the implementation the following stable versions are being used: Python Version: 3.9.7

    \section{User Documentation}
        All the features will be describes in a comprehensive and detailed user documentation which will cleary describe
        the input data and attributes a user can present to  respectively define flow of the program.

        % A documentation of the cluster-based techniques will be provided, as well as comments in the source code to help developers understand the context behind the code.

    \section{Assumptions and Dependencies}

        Its assumed that a clustering in polynomial time is possible and the time complexity does not lead to runtimes greater 
        than five minutes. \par
        Furthermore its assumed that the example OCEL data files presented at
        \href{http://ocel-standard.org/}{ocel-standard.org}
        are representive. \par
        Its assumed that every user of the product has basic knowledge of computer science eventhought the team will 
        put effort in making the project accessible to a wide audiency. \par

        Additionally - as the project is based on several libraries and different software - it depends on the availability of them.

        % The app is intended to work on all modern operating systems. Nevertheless, the functionality of the clustering-techniques depends on the availability of a Python Compiler (3.9.x and above) and PM4PY 2.2.20.1. The functionality of the implementation will depend on the availability of these components.

\chapter{External Interface Requirements}
    \section{User Interfaces}
        \paragraph*{GUI} A web service framework will be implemented and deployed to allow the user to interact with the controls to adjust the parameters for the clustering process to their liking. A visual representation of the Direct-Follow-Graph will be displayed after the graph has been produced. Moreover, they will have access to a variety of other critical features such as buttons for importing/exporting OCELs or DFGs etc.
        \paragraph*{Core program} The core part of the software will be a docker container inside which the software will run.
        The software will have three inputs:
        \begin{itemize}
            \item OCEL-data as a file.
            \item selection of the clustering mode
            \item Set of attributes to use for the clustering
        \end{itemize}

        \paragraph*{Jupyter Notebook Interface} The project team will provide an interactive User Interface based on Jupyter Notebooks which is
        accessible via a Web-Browser to set the inputs needed for running the program. The export of the programm will be visible
        inside the Notebook as well.

        % The project final product will serve as an extension to the existing OCEL libraries in PM4PY hence no user interface is required nor provided to run the clustering-technique.

    \section{Software Interfaces}
        As already described in the section \textit{User interfaces}, the inputs to the core program can 
        be considered as a software interface. Depending on Docker this will work via a web-request or possibly via 
        a command line interface or both.

        % The developer or user can choose a Python-compatible IDE of his liking and import the PM4PY library as well as the clustering libraries that this project implements.

\chapter{System Features}
    \section{Input Data}
        Import data in a standardized format.
        The program needs two pools of data. 
        On one hand it, requires data about objects 
        used during a process which need to have unique identifiers and a given object type.
        On the other hand, the software requires an event log which has to
        provide the following information about every event: unique identifier,
        event-type (activity), timestamp and used objects. The objects assigned to a 
        event have to be a subset of the objects provided to the program.
        \par
        A User should be able to define a subset of the given objects which then are 
        used to cluster based on these objects.
        A User should also be granted the possibility to select between the \textit{all}
        and \textit{existence} clustering approach. These approaches are defined 
        under Overall Description.
    \section{Internal representation of data}
        The program needs an internal fast data structure to hold
        the data about events and objects to apply clustering algorithms on them.
    \section{Output data}
        The program should show a OC-DFG (described under Overall Description)
        which shows the flow of events during a process filtered based on the
        given objects and the selected mode (\textit{all} or \textit{existence}).
    \section{Measure the complexity of a OC-DFG or the relevance of its nodes}
        To reduce the complexity of a DFG, a measurement needs to be performed to determine how 
        \textit{important} a node is. For example, this can be based on the frequency of an event
        in a process flow or how much time is spent on it.
    \section{Reduce complexity of OC-DFG}
        The internally generated DFG should be compressed in a way that shrinks
        the complexity of the DFG. In the end, a user can select
        how complex the displayed DFG should be. For this purpose,
        the approach used in Celonis can be a role model. Every node gets
        to be defined through a relevance measurement and the user can filter the nodes
        based on this measurement.
    \section{Clustering of Events}
        The events should be clustered based on common events that are used in single 
        events. 
        \par
        \textcolor{red}{TBD: Clustering in multiple clusters or deciding if a event is considered or Nonfunctional
        (essentially two clusters).}

    % In this approach, to avoid convergence, we assign an event to a cluster, if the cluster contains all the objects that exist in that event. Following this approach, we miss the event whose objects are distributed in several clusters. Nevertheless, following this approach no duplication of events occurs [2].

    % We directly assign events to the clusters by considering that the event should contain at least one of the objects in the cluster.

\chapter{Other Nonfunctional Requirements}
    \section{Performance Requirements}
        No specific Performance Requirements except that its runtime should not exceed minutes.
        
        % There are no specific performance requirements to consider.

    \section{Safety Requirements}
        There are no Safety Requirements to propose.

        % There are no specific safety requirements to consider.

    \section{Security Requirements}
        There are no Security Requirements to propose.

        % There are no specific security requirements to consider.

    \section{Software Quality Attributes}
        The software should be well-documented. The code should be public available and well documented as well in a manner
        that other software developers can use the information to extend the features of the software.
        The software should not use any deprecated functions and should aim to use current versions of included software.
   
        % There are no specific software quality attributes to consider.

    \section{Business Rules}
        As the project will be developed in an educational and researchable context, there are no special business rules to consider.

        % There are no specific business rules to consider.

\chapter*{Appendix}
\bibliographystyle{plain}
\bibliography{references}

% add other chapters and sections to suit
\end{document}